#include <GL/glew.h>

#include "texture.h"
#include "opengl/texture-gl.h"

TextureGL::TextureGL()
{
	w = 0;
	h = 0;

	pixels = 0;
	tex = 0;
}

TextureGL::~TextureGL()
{
	glDeleteTextures(1, &tex);
}

void TextureGL::update()
{
	if(!tex) {
		glGenTextures(1, &tex);
		glBindTexture(GL_TEXTURE_2D, tex);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	}
	else {
		glBindTexture(GL_TEXTURE_2D, tex);
	}

	glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, w, h, 0, GL_RGB, GL_UNSIGNED_BYTE, pixels);
	glGenerateMipmap(GL_TEXTURE_2D);
}